% SQL

% consulta 1
% Recuperar el nombre y direccion de todos los empleados que trabajan para el departamento de 'Investigacion' 

sql1 := select nombre, direccion
	from empleados E, departamentos D
	where D.dnombre = 'Investigacion' and E.dep = D.dnumero;

% consulta 2
% Para cada proyecto localizado en 'Ciudad Real', listar el numero del proyecto, el numero del departamento que lo controla,
% y los apellidos, nombre y direccion del jefe del departamento

sql2 := select pnumero, P.dep, apel1, apel2, nombre, direccion
	from proyectos P, departamentos D, empleados E
	where pciudad='Ciudad Real' and P.dep=D.dnumero and D.jefe=E.dni;

% Encontrar los nombres de empleados que trabajan en todos los proyectos controlados por el departamento 5

sql3 := select apel1, apel2, nombre
	from empleados E
	where  not exists ( select *
		           from proyectos P
		           where P.dep=5 and not exists ( select *
				                from trabaja_en T
				                where T.emp=E.dni and T.pro=P.pnumero));

% consulta 4
% Listar los numeros de proyecto para los proyectos que involucran a un empleado cuyo primer apellido es 'Ruiz', bien como trabajador
% bien como jefe del departamento que controla el proyecto

sql4(pro) := (select pnumero
	from proyectos P, departamentos D, empleados E
	where  P.dep=D.dnumero and D.jefe=E.dni and E.apel1='Ruiz')
                        union
                        (select pnumero
	from proyectos P, trabaja_en T, empleados E
	where P.pnumero=T.pro and T.emp=E.dni and E.apel1='Ruiz');

% consulta 5
% Listar el nombre y apellidos de todos los empleados que tienen 2 o mas parientes

	% nmero de parientes de cada empleado (esto equivale a una orden CREATE VIEW)
	v51(emp,npar) := select dni, count(*)
		 from empleados E, parientes P
		 where E.dni=P.emp
		 group by dni;

sql5 := select nombre, apel1, apel2
	from empleados E, v51
	where E.dni=v51.emp and v51.npar>=2;

% consulta 6
% Listar el nombre y apellidos de los empleados que no tienen parientes

sql6 := select nombre, apel1, apel2
	from empleados E
	where not exists ( select *
		          from parientes P
		          where E.dni=P.emp);

% consulta 7
% Listar el nombre y apellidos de los jefes de departamento que tienen al menos un pariente

sql7 := select nombre, apel1, apel2
	from empleados E
	where exists (select * from parientes P where E.dni=P.emp)
	    and exists (select * from departamentos D where D.jefe=E.dni);
 

